@ECHO off

REM This batch will compile a QuickBASIC program that uses the compiler-only
REM instruction "B$ASSN" (which prevents compilation of the program from the
REM IDE.) The program doesn't link to any extra library (apart from QB.LIB.)
SET srcFile=%1

REM Where QuickBASIC libraries are located (QB.LIB, BQLB45.LIB)
REM Remember to set your QuickBASIC directory as a fallback directory for
REM missing applications in AUTOEXEC.BAT: "SET PATH=C:\UTILS\QB45E\"
SET qbLibPath=C:\UTILS\QB45E\LIB\

REM If the source file doesn't exist, abort batch
IF NOT EXIST %srcFile%.BAS GOTO batchEnd

REM Delete .OBJ file if present
IF NOT EXIST %srcFile%.OBJ GOTO noOBJ
DEL %srcFile%.OBJ
:noOBJ

REM Write ~QBLNK.TMP
ECHO /EX /NOE /NOD:BRUN45.LIB %srcFile%>~QBLNK.TMP
ECHO %srcFile%.EXE>>~QBLNK.TMP
ECHO. >>~QBLNK.TMP
ECHO %qbLibPath%BCOM45.LIB+>>~QBLNK.TMP
ECHO %qbLibPath%QB.LIB>>~QBLNK.TMP

REM Compile library
BC.EXE %srcFile%.BAS/O/T/C:512;
LINK.EXE @~QBLNK.TMP

REM Delete temporary response files
DEL ~QBLNK.TMP
DEL %srcFile%.OBJ

:batchEnd