CONST vgaSolid = 0
CONST vgaSprite = -1

DECLARE SUB yScreen (enable AS INTEGER)
DECLARE SUB yScreenCopy ()
DECLARE SUB yScreenClear (clr as integer)

DECLARE SUB yViewport (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
DECLARE SUB yCapture (filename AS STRING) ', pg as integer)
DECLARE SUB yMemInfo (sprBnk AS INTEGER, sldBnk AS INTEGER)
DECLARE SUB yFlip ()

DECLARE FUNCTION yImgNew% (w AS INTEGER, h AS INTEGER, isSprite AS INTEGER)
DECLARE SUB yImgInfo (id AS INTEGER, w AS INTEGER, h AS INTEGER)
DECLARE SUB yImgFree (id AS INTEGER)
DECLARE SUB yImgDraw (id AS INTEGER, x AS INTEGER, y AS INTEGER)
DECLARE SUB yImgSetOrigin (id AS INTEGER, x AS INTEGER, y AS INTEGER)

DECLARE FUNCTION yImgFromFile% (filename AS STRING, isSprite AS INTEGER)

DECLARE SUB yImgPxlGo (id AS INTEGER, x AS INTEGER, y AS INTEGER)
DECLARE SUB yImgPxlSet (id AS INTEGER, clr AS INTEGER)
DECLARE FUNCTION yImgPxlGet% (id AS INTEGER)
DECLARE SUB yImgPxlSetRow (id AS INTEGER, srcSeg AS INTEGER, srcOfs AS INTEGER)

declare FUNCTION yCMapSet% (imgId AS INTEGER, isSprite as integer, first AS INTEGER, last AS INTEGER)
DECLARE SUB yCMapFree (id AS INTEGER)
declare SUB yPrint (id AS INTEGER, x AS INTEGER, y AS INTEGER, msg AS STRING)
declare SUB yPrintColor (id AS INTEGER, clr as integer, x AS INTEGER, y AS INTEGER, msg AS STRING)

DECLARE SUB yPalApply (id AS INTEGER, first AS INTEGER, count AS INTEGER)
DECLARE SUB yPalGet (id AS INTEGER, first AS INTEGER, count AS INTEGER)
DECLARE SUB yPalFree(id as integer)
DECLARE SUB yPalGrayscale (id AS INTEGER, first AS INTEGER, count AS INTEGER)
DECLARE SUB yPalShift(first as integer, last as integer, offset as integer)
DECLARE FUNCTION yPalFromFile% (filename AS STRING)
DECLARE FUNCTION yPalNew% ()

'
' bonus routines
'
DECLARE FUNCTION fileExists% (flName AS STRING)

DECLARE FUNCTION memAlloc% (numBytes AS LONG)
DECLARE SUB memFree (segAdr AS INTEGER)
DECLARE SUB memCpy (srcSeg AS INTEGER, srcOfs AS INTEGER, dstSeg AS INTEGER, dstOfs AS INTEGER, count AS INTEGER)

